#include <iostream>
#include <vector>
#include <cmath>
#include <set>
#include <algorithm>
#include <cstdio>

using namespace std;

#define x first
#define y second
#define sqr(x) (x) * (x)

class point{
public:
    double x, y;
    point() {}
    point(double _x, double _y) {
        x = _x;
        y = _y;
    }
};

#define EPS 1e-8

bool operator<(point a, point b) {
//    return (a.x == b.x && a.y < b.y) || a.x < b.x;
    return (abs(a.x - b.x) <= EPS && a.y - b.y <= -EPS) || a.x - b.x <= -EPS;
}
bool cmp(point a, point b) {
    if (a.x == 0 && b.x == 0)
        return a.y < b.y;
    return a.y * b.x < a.x * b.y;
}

double dist(double x1, double y1, double x2, double y2) {
    return sqrt(sqr(x1 - x2) + sqr(y1 - y2));   
}

int main() {
    freopen("cake.in","r",stdin);
    freopen("cake.out","w",stdout);

    int n, r, cx, cy;
    cin >> n >> r >> cx >> cy;
    vector<pair<int , int> > a;
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].x >> a[i].y;
        a[i].x -= cx;
        a[i].y -= cy;
    }

    a.push_back(make_pair(0, 1));
    a.push_back(make_pair(1, 0));
    a.push_back(make_pair(-1, 0));
    a.push_back(make_pair(0, -1));

    set<point > ans2;
    for (int i = 0; i < a.size(); ++i) {
        double len = dist(a[i].x, a[i].y, 0, 0);
        if (len == 0)
            continue;
        point tmp;
        tmp.x = a[i].x / len * r;
        tmp.y = a[i].y / len * r;
        ans2.insert(tmp);
        tmp.x *= -1;
        tmp.y *= -1;
        ans2.insert(tmp);
    }

    ///


    vector<point> ans;
    for (set<point >::iterator i = ans2.begin(); i != ans2.end(); ++i) {
        point tmp = *i;
        tmp.x -= ans2.begin()->x;
        tmp.y -= ans2.begin()->y;
        ans.push_back(tmp);
    }

    sort(ans.begin() + 1, ans.end(), cmp);
        

    ///

    cout.precision(6);

    cout << ans.size() << fixed << endl;
    for (int i = 0; i < ans.size(); ++i)
//    for (set<point >::iterator i = ans.begin(); i != ans.end(); ++i)
        cout << ans[i].x + cx + ans2.begin()->x << " " << ans[i].y + cy + ans2.begin()->y << endl;
}

