#pragma comment(linker, "/STACK:1000000000")
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <cassert>
#include <ctime>
#include <cstring>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <list>
#include <deque>
#include <queue>
#include <sstream>
#include <iostream>
#include <algorithm>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

const double pi = acos(-1.0);
const double eps = 1e-10;
const int lim = 222;

int n;
double r, xc, yc;

inline double sqr(double x) {
	return x * x;
}

inline double sol(double c, double a) {
	return sqrt(fabs(sqr(c) - sqr(a)));
}

double dist(const pair <double, double>& a, const pair <double, double>& b) {
	return sqrt(sqr(a.fs - b.fs) + sqr(a.sc - b.sc));
}

bool comp(const pair <double, double>& a, const pair <double, double>& b) {
	if (fabs(a.fs - b.fs) < r * eps) {
		if (fabs(a.sc - b.sc) < r * eps)
			return false;
		else
			return a.sc < b.sc;
	} else {
		return a.fs < b.fs;
	}
}

int main() {
    freopen("cake.in","r",stdin);
    freopen("cake.out","w",stdout);

    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    scanf("%d%lf%lf%lf", &n, &r, &xc, &yc);
    
    vector <pair <double, double> > ans;
    ans.pb(mp(0, r));
    ans.pb(mp(0, -r));
    ans.pb(mp(r, 0));
    ans.pb(mp(-r, 0));

    double x, y;
    for (int i = 0; i < n; i++) {
    	scanf("%lf%lf", &x, &y);
    	x -= xc;
    	y -= yc;
        ans.pb(mp(x, sol(r, x)));
        ans.pb(mp(x, -sol(r, x)));
        ans.pb(mp(sol(r, y), y));
        ans.pb(mp(-sol(r, y), y));
    }

    vector <pair <double, int> > ansg;
    sort(ans.begin(), ans.end(), comp);

    int i = 0;
    int j = 0;
    while (i < (int) ans.size()) {
    	while (j < (int) ans.size() && !comp(ans[i], ans[j]))
    		j++;
    	ansg.pb(mp(atan2(ans[i].sc, ans[i].fs), i));
    	i = j;
    }

    if ((int) ansg.size() > lim) {
    	srand(784);
    	random_shuffle(ansg.begin(), ansg.end());
    	ansg.resize(lim);
    }

    sort(ansg.begin(), ansg.end());
    
    printf("%d\n", (int) ansg.size());
    for (int i = 0; i < (int) ansg.size(); i++)
    	printf("%.6lf %.6lf\n", ans[ansg[i].sc].fs + xc, ans[ansg[i].sc].sc + yc);

    return 0;
}