#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <cassert>
#include <ctime>
#include <cstring>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <list>
#include <deque>
#include <queue>
#include <sstream>
#include <iostream>
#include <algorithm>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

const double pi = acos(-1.0);
const int lim = 222;
const double eps = 1e-6;

int n, r;
double xc, yc;

bool comp(const pair <double, double>& a, const pair <double, double>& b) {
	if (fabs(a.fs - b.fs) < eps) {
		if (fabs(a.sc - b.sc) < eps)
			return false;
		else
			return a.sc < b.sc;
	} else {
		return a.fs < b.fs;
	}
}


int main() {
    freopen("cake.in", "r", stdin);
    freopen("cake.out", "w", stdout);

    scanf("%d%d%lf%lf", &n, &r, &xc, &yc);
    
    vector <pair <double, double> > ans;

    for (int i = -r; i <= r; i++)
    	for (int j = -r; j <= r; j++)
    		if (i * i + j * j == r * r)
    			ans.pb(mp(i, j));
    int mylim = (int) lim - ans.size();
    for (int i = 0; i < mylim; i++) {
    	ans.pb(mp(cos(2 * pi * i / mylim) * r, sin(2 * pi * i / mylim) * r));
    }

   	cout.precision(20);
   	
   	vector <pair <double, int> > ansg;
   	sort(ans.begin(), ans.end(), comp);

    int i = 0;
    int j = 0;
    while (i < (int) ans.size()) {
    	while (j < (int) ans.size() && !comp(ans[i], ans[j]))
    		j++;
    	ansg.pb(mp(atan2(ans[i].sc, ans[i].fs), i));
    	i = j;
    }

    if ((int) ansg.size() > lim) {
    	srand(23);
    	random_shuffle(ansg.begin(), ansg.end());
    	ansg.resize(lim);
    }

    sort(ansg.begin(), ansg.end());
    
    printf("%d\n", (int) ansg.size());
    for (int i = 0; i < (int) ansg.size(); i++)
    	printf("%.10lf %.10lf\n", ans[ansg[i].sc].fs + xc, ans[ansg[i].sc].sc + yc);

    return 0;	
    /*
    printf("%d\n", lim);
    for (int i = 0; i < lim; i++) {
    	printf("%.10lf %.10lf\n", cos(2 * pi * i / lim) * r + xc, sin(2 * pi * i / lim) * r + yc);
    }
    */
    
    return 0;
}