#include <cstdio>
#include <cstring>
#include <algorithm>
const int N = (int) 1e6 + 10;
const unsigned long long P = 17239;
char s[N], t[N], opt_t[N];
bool used[N];
int res_len, res[N], opt_res_len, opt_res[N];
unsigned long long h[N], opt_h[N], ppow[N];
int j, len, n, k;

void calc_h(char * t, unsigned long long * h, int len) {
	ppow[0] = 1, h[0] = 0, t[len] = 0;
	for (int i = 0; i < len; ++i) {
		h[i + 1] = (h[i] * P + t[i]);
		ppow[i + 1] = (ppow[i] * P);
	}
}

unsigned long long get(unsigned long long * h, int i, int len) {
	return (h[i + len] - h[i] * ppow[len]);
}

int get_lcp(unsigned long long * h1, int p1, unsigned long long * h2, int p2) {
	int l = 0, r = len + 1;
	while (l + 1 < r) {
		int q = (l + r) / 2;
		((get(h1, p1, q) == get(h2, p2, q)) ? l : r) = q;
	}
	return l;
}

void get_minimal_cyclic_shift(char * t, unsigned long long * h, int& res_len, int * res) {
	memcpy(t + len, t, len * sizeof(t[0]));
	calc_h(t, h, 2 * len);
	int start = 0;
	for (int i = 0; i < len; ++i) {
		int lcp = get_lcp(h, start, h, i);
		if ((i == 0) || (t[i + lcp] < t[start + lcp]))
			res_len = 0, start = i;
		if ((i == 0) || (t[i + lcp] == t[start + lcp]))
			res[res_len++] = i;
	}
	memcpy(t, t + start, len * sizeof(t[0])), t[len] = 0;
}

int main() {
	freopen("games.in", "r", stdin);
	freopen("games.out", "w", stdout);
	scanf("%d%d%s", &n, &k, s);
	for (int i = 0; i < n; ++i) {
		if (used[i]) continue;
		for (j = i, len = 0; !used[j]; j = (j + k + n) % n)
			t[len++] = s[j], used[j] = true;
		get_minimal_cyclic_shift(t, h, res_len, res);
		calc_h(opt_t, opt_h, len);
		calc_h(t, h, len);
		int lcp = get_lcp(h, 0, opt_h, 0);
		if ((i == 0) || (t[lcp] < opt_t[lcp])) {
			opt_res_len = 0;
			memcpy(opt_t, t, len * sizeof(t[0]));
		}
		if ((i == 0) || (t[lcp] == opt_t[lcp]))
			for (j = 0; j < res_len; ++j)
				opt_res[opt_res_len++] = (i + (res[j] * 1LL * k)) % n;
	}
	std::sort(opt_res, opt_res + opt_res_len);
	printf("%sinite\n", (opt_res_len == 1) ? "F" : "Inf");
	for (int i = 0; i < opt_res_len; ++i)
		printf("%d%c", (opt_res[i] + n) % n + 1, " \n"[i == opt_res_len - 1]);
	return 0;
}