//	#pragma comment(linker, "/STACK:60000000")
#include <iostream>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <cstdlib>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <string>

#define pb push_back
#define mp make_pair
#define fs first
#define sc second
#define len(x) (int((x).size()))
#ifdef LOCALD
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) {}
#endif

#ifdef __linux__
#define I64d "%lld"
#else
#define I64d "%I64d"
#endif

typedef long long int int64;
typedef long double ext;

const int inf = 1000000000;


using namespace std;

int n, k, f;

const int maxk = 20;

vector<int> a;

set<vector<int> > s;

bool check(){
	int x = 1, cnt = 0;
	while (x >= 0){
		cnt++;
		x = a[x];
	}
	return cnt == k - 1;
}

bool ismoveable(int x){
	if (x == 0)
		return false;
	for (int i = 0; i < k; i++)
		if (a[i] == x)
			return false;
	return true;			
}




bool brute(){
	if (s.find(a) != s.end())
		return false;
	s.insert(a);		
	/*eprintf("NEW\n");
	for (int i = 0; i < k; i++)
		eprintf("P[%d] = %d\n", i, a[i]);
	eprintf("\n");				
	fflush(stderr);	*/
	if (check())
		return true;
	bool res = false;
	for (int i = 0; i < k; i++){
		if (!ismoveable(i))
			continue;
		if (i < k - 1){
			if (ismoveable(i + 1) && (a[i + 1] != -2)){
				int x = a[i];
				a[i] = i + 1;
				res = brute();
				a[i] = x;
				if (res)
					return true;
			}		
		}
		for (int j = -1; j >= -2; j--){
			int x = a[i];
			a[i] = j;
			int cnt = 0;
			for (int x = 0; x < k; x++){
				if (a[x] == j)
					cnt++;
			}	
			bool ok;
			if (j == -1)
				ok = cnt <= n;
			else if (j == -2)
				ok = cnt <= f;
			if (ok)				
				res = brute();
			a[i] = x;
			if (res)
				return true;
				
		}
	}		
	return false;
}

int tests;



int main() {
	assert(freopen("solitaire.in", "rt", stdin));
	assert(freopen("solitaire.out", "wt", stdout));
	#ifdef LOCALD
	//assert(freopen("solitaire.dbg", "wt", stderr));
	#endif
	scanf("%d", &tests);
	for (int test = 0; test < tests; test++){	      	
		scanf("%d %d %d", &n, &f, &k);	
		n++;
		if (n == 0){
			printf("NO\n");
			return 0;		
		}
		a.resize(k);		
		a[0] = -1;
		if (k > 1) {
			a[k - 1] = 0;
			for (int i = k - 2; i >= 1; i--)
				a[i] = i + 1;
		}	
		s.clear();
		if (brute())
			printf("YES\n");
		else
			printf("NO\n");	
	}	
				/*eprintf("BRUTE\n");
				fflush(stderr);	*/

				
	/*for (n = 1; n <= 8; n++){
		for (f = 0; f <= 4; f++){		
			if ((n + f) > 7)
				continue;
			k = 1;
			eprintf("N = %d F = %d\n", n, f);
			int l = 1;
			int r = 100;
			while (r - l > 1){
				int m = (l + r) / 2;
				k = m;
				eprintf("K = %d\n", k);
				a.resize(k);		
				a[0] = -1;
				if (k > 1) {
					a[k - 1] = 0;
					for (int i = k - 2; i >= 1; i--)
						a[i] = i + 1;
				}	
				s.clear();
				/*eprintf("BRUTE\n");
				fflush(stderr);
				if (brute())
					l = m;
				else
					r = m;	

			}
			printf("(N = %2d, F = %2d, Kmax = %2d) ", n, f, l);
		}				
		eprintf("\n");
		printf("\n");
	}*/
    return 0;
}
