#include<iostream>
#include<vector>
#include<cstdio>

using namespace std;

vector< vector<int> > V;
vector<int> ringroad;
vector<int> used;
int curO;

int dfs_connectivity(int v) {
    used[v] = 1;
    for (vector<int>::iterator it = V[v].begin(); it < V[v].end(); ++it) {
        if (!used[*it]) dfs_connectivity(*it);
    }
}

int dfs_center(int v, int cnt = 0) {
    used[v] = 1;
    if (v != curO && V[v].size() == 4) cnt++;
    if (V[v].size() == 1) return cnt == 1;
    if (v == curO) {
        for (vector<int>::iterator it = V[v].begin(); it < V[v].end(); ++it) {
            if (used[*it]) return 0;
            if (!dfs_center(*it, cnt)) return 0;
        }
        return 1;
    } else if (V[v].size() == 4) {
        for (vector<int>::iterator it = V[v].begin(); it < V[v].end(); ++it) {
            if (!used[*it] && V[*it].size() != 4) {
                return dfs_center(*it, cnt);
            }
        }
    } else {
        for (vector<int>::iterator it = V[v].begin(); it < V[v].end(); ++it) {
            if (!used[*it]) {
                return dfs_center(*it, cnt);
            }
        }
    }
    return 0;
}

int main(){
    freopen("map.in", "r", stdin);
    freopen("map.out", "w", stdout);
    int n, m;
    cin >> n >> m;
    if (n < 7) {
        cout << "NO" << endl;
        cerr << "Too little vertices: " << n << endl;
        return 0;
    }
    V.resize(n);
    ringroad.reserve(n);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u; --v;
        V[u].push_back(v);
        V[v].push_back(u);
    }

    curO = -1;
    for (int i = 0; i < n; ++i) {
        if (V[i].size() == 4) {
            ringroad.push_back(i);
        } else if (V[i].size() != 1 && V[i].size() != 2) {
            if (curO == -1) {
                curO = i;
            } else {
                cout << "NO" << endl;
                cerr << "There is at least two unstandart vertices: (" << curO+1 << ", " << i+1 << ")" << endl;
                return 0;
            }
        }
    }

    used.resize(n);
    dfs_connectivity(0);
    for (vector<int>::iterator it = used.begin(); it < used.end(); ++it) {
        if (*it == 0) {
            cout << "NO" << endl;
            cerr << "Graph is not connected: there is no way (1, " << *it+1 << ")" << endl;
            return 0;
        }
    }

    if (curO != -1) {
        used.clear(); used.resize(n);
        if (dfs_center(curO)) {
            cout << "YES" << endl;
            cerr << "Ok, graph is good, center: " << curO+1 << endl;
            return 0;
        } else {
            cout << "NO" << endl;
            cerr << "Only vertex " << curO+1 << " seems to be center but it doesn't" << endl;
            return 0;
        }
    } else {
        for (vector<int>::iterator it = ringroad.begin(); it < ringroad.end(); ++it) {
            curO = *it;
            used.clear(); used.resize(n);
            if (dfs_center(curO)) {
                cout << "YES" << endl;
                cerr << "Ok, graph is good, center: " << curO+1 << endl;
                return 0;
            }
        }
        cout << "NO" << endl;
        cerr << "Only vertexes (";
        for (int i = 0; i < 4; ++i) cerr << ringroad[i]+1 << ", ";
        cerr << ringroad[4]+1;
        cerr << ") seems to be center but they doesn't" << endl;
        return 0;
    }
}