#include <iostream>
#include <cstdio>
#include <vector>
#include <cassert>
#include <algorithm>
#include <utility>
using namespace std;

// takes string with parametrs of len_steps and aumount of needed most rare quests

#define MAX_LEN 100000
#define MIN_LEN 7000

#define MAX_PRIME 10000000
#define MAX_REQUEST_N ((unsigned int)100000)


int prime_pref[MAX_PRIME + 10];
//amount of prime numbers on prefix [0 ; i]

void fill_primes()
{
	for (int i = 2; i <= MAX_PRIME; ++i) {
		if (prime_pref[i] == 0) {
			for (int j = i + i; j <= MAX_PRIME; j += i) {
				prime_pref[j] = 1;
			}
		}
		prime_pref[i] = prime_pref[i - 1] + !prime_pref[i];
	}
}

int main(int argc, char* argv[])
{
        fill_primes();
	srand(239);
	ios::sync_with_stdio(false);

	int len_min, len_step, len_max;
	assert(sscanf(argv[1], "%d:%d:%d", &len_min, &len_step, &len_max) == 3);
	assert(len_step > 0);
	assert(len_min > 0);

	unsigned int amount = 0;
	assert(sscanf(argv[2],"%u", &amount) == 1);

	vector <pair <int, int> > quests;

	for (int len = len_min; len <= len_max; len += len_step) {
		vector <int> cnt(len + 1);
		for (int x = 2; x + len - 1 <= MAX_PRIME; ++x) {
			++cnt[prime_pref[x + len - 1] - prime_pref[x -1]];
		}
		vector <pair <int, int> > non_empty(0);
		for (int x = MIN_LEN; x <= len; ++x) {
			if (cnt[x]) {
				non_empty.push_back(make_pair(cnt[x], x));
			}
		}
		sort(non_empty.begin(), non_empty.end());
		for (int i = 0; i < min(non_empty.size(), amount); ++i) {
			quests.push_back(make_pair(len, non_empty[i].second));
		}
	}
	random_shuffle(quests.begin(), quests.end());
	int n = min(quests.size(), MAX_REQUEST_N);
	cout << n << endl;
	for (int i = 0; i < n; ++i) {
		cout << quests[i].first << " " << quests[i].second << endl;
	}

	return 0;
}
