#include <iostream>
#include <cstdio>
#include <vector>
#include <cassert>
#include <algorithm>
#include <utility>
using namespace std;

// takes string with parametrs of len_steps and aumount of needed most rare quests

#define MAX_LEN 100000
#define MIN_LEN 7000

#define MAX_PRIME 10000000
#define MAX_REQUEST_N ((unsigned int)100000)

int big_rand(int a, int b)
{
	long long x = (long long)rand() * RAND_MAX + rand();
	return a + x % (b - a + 1);
}

int prime_pref[MAX_PRIME + 10];
//amount of prime numbers on prefix [0 ; i]

vector <int> primes;

void fill_primes()
{
	for (int i = 2; i <= MAX_PRIME; ++i) {
		if (prime_pref[i] == 0) {
			primes.push_back(i);
			for (int j = i + i; j <= MAX_PRIME; j += i) {
				prime_pref[j] = 1;
			}
		}
		prime_pref[i] = prime_pref[i - 1] + !prime_pref[i];
	}
}

int main(int argc, char* argv[])
{
	fill_primes();
	ios::sync_with_stdio(false);

	int test_n = atoi(argv[1]);
	int seed = atoi(argv[2]);
	srand(seed);
	cout << test_n << endl;
	vector <vector <int> > tests(100000);
	for (int i = 0; i < primes.size(); i += 100) {
		for (int j = i + 1; primes[j] - primes[i] + 1 <= MAX_LEN && j < primes.size(); ++j) {
			int len = primes[j] - primes[i] + 1;
			tests[j - i + 1].push_back(len);
		}
	}
	int max_non_empty = 0;
	for (int i = 0; i < tests.size(); ++i) {
		if (tests[i].size() > 0) {
			max_non_empty = i;
		}
	}
	for (int i = 0; i < test_n; ++i) {
		int cnt = big_rand(MIN_LEN, max_non_empty);
		int len = cnt;
		if (tests[cnt].size() > 0) {
			len = tests[cnt][big_rand(0, tests[cnt].size() - 1)];
		}
		cout <<  len + rand() % 2 << " " << cnt << endl;
	}
	return 0;
}
