#include <iostream>
#include <cstdio>
#include <vector>
#include <cassert>
#include <algorithm>
#include <utility>
using namespace std;

// takes two strings with discribing of test_gen steps
/*
Example : gen_steps '14:10:24' '0:3:8'
	6
	14 0
	24 6
	24 3
	14 6
	24 0
	14 3
*/

#define MAX_REQUEST_N ((unsigned int)100000)

int main(int argc, char* argv[])
{
	srand(239);
	ios::sync_with_stdio(false);
	int len_min, len_max, len_step;
	int quest_min, quest_max, quest_step;

	assert(sscanf(argv[1], "%d:%d:%d", &len_min, &len_step, &len_max) == 3);
	assert(len_min > 0);
	assert(len_step > 0);
	assert(sscanf(argv[2], "%d:%d:%d", &quest_min, &quest_step, &quest_max) == 3);
	assert(quest_min >= 0);
	assert(quest_step > 0);

	vector <pair <int, int> > quests;
	for (int len = len_min; len <= len_max; len += len_step) {
		for (int quest = quest_min; quest <= min(quest_max, len); quest += quest_step) {
			quests.push_back(make_pair(len, quest));
			if (quests.size() > 2 * MAX_REQUEST_N) {
				quest_max = len_max = 0;
			}
		}
	}
	random_shuffle(quests.begin(), quests.end());
	int n = min(quests.size(), MAX_REQUEST_N);
	cout << n << endl;
	for (int i = 0; i < n; ++i) {
		cout << quests[i].first << " " << quests[i].second << endl;
	}

	return 0;
}
